﻿using System;
using System.Collections.Generic;
using System.Data.SqlTypes;
using System.Diagnostics;
using System.Linq;
using System.Text;
//using Microsoft.SqlServer.Types;
using ThinkGeo.MapSuite.Core;

namespace ConsoleApplication1
{
	class Program
	{
		// ThinkGEO version 6.0.45.0
		// dlls from WpfDesktopEditionFull6.0.45.0DllPackage\Wpf Desktop Edition - Strong Named
		// SqlServerTypes_X86

		static void Main(string[] args)
		{
			const string wktString =
				"GEOMETRYCOLLECTION(LINESTRING(37.500865295995 55.8699963530526,37.5005347600672 55.8701379039558,37.5004185189027 55.8700521070277,37.5007490538992 55.8699105560081,37.5007879079785 55.8699391559931,37.5008267450612 55.8699225559831),POLYGON((37.5008801450022 55.8698888779618,37.5012943521142 55.8699068629649,37.5012795049697 55.8700143380556,37.500865295995 55.8699963530526,37.5008267450612 55.8699225559831,37.5008752499707 55.8699246740434,37.5008801450022 55.8698888779618)))";
			var feature = new ThinkGeo.MapSuite.Core.Feature(wktString);

			if (!feature.IsValid())
			{
				// doesn't assert here => ThinkGEO feature is valid
				Debug.Assert(false);
			}

			/*
			try
			{
				var sqlGeography = SqlGeography.STGeomFromWKB(new SqlBytes(wkb), 4326);
			}
			catch (Exception)
			{
				// doesn't assert here => sql representation is valid
				Debug.Assert(false);
			}
			*/

			if (feature.GetShape() is GeometryCollectionShape)
			{
				var wkt = feature.GetShape().GetWellKnownText();

				// doesn't assert here => wkt is still the same
				Debug.Assert(wktString.Equals(wkt));
			}

			// next line produces StackOverflowException
			var boundingBox = feature.GetShape().GetBoundingBox();

		}
	}
}
